------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Buttons;
with Qt4.Wizard_Pages;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Wizard_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Wizard_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Wizards is

   function addPage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Page : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, addPage_0_wrapper,
                     "__Qt4Ada_QWizard_addPage_0_wrapper");

   function button_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Page : Qt4.Wizards.Wizard_Wizard_Button)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, button_0_wrapper,
                     "__Qt4Ada_QWizard_button_0_wrapper");

   procedure buttonText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, buttonText_0_wrapper,
                     "__Qt4Ada_QWizard_buttonText_0_wrapper");

   function currentId_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, currentId_0_wrapper,
                     "__Qt4Ada_QWizard_currentId_0_wrapper");

   function currentPage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, currentPage_0_wrapper,
                     "__Qt4Ada_QWizard_currentPage_0_wrapper");

   procedure field_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Name : not null access constant Qt4.Strings.Internals.QString;
     Returns : not null access Qt4.Variants.Internals.QVariant);
   pragma Import (C, field_0_wrapper,
                     "__Qt4Ada_QWizard_field_0_wrapper");

   function hasVisitedPage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Id : Qt4.Q_Integer)
       return Qt4.bool;
   pragma Import (C, hasVisitedPage_0_wrapper,
                     "__Qt4Ada_QWizard_hasVisitedPage_0_wrapper");

   function page_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Id : Qt4.Q_Integer)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, page_0_wrapper,
                     "__Qt4Ada_QWizard_page_0_wrapper");

   procedure pixmap_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Id : Qt4.Wizards.Wizard_Wizard_Pixmap;
     Returns : not null access Qt4.Pixmaps.Internals.QPixmap);
   pragma Import (C, pixmap_0_wrapper,
                     "__Qt4Ada_QWizard_pixmap_0_wrapper");

   procedure setButton_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Button : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setButton_0_wrapper,
                     "__Qt4Ada_QWizard_setButton_0_wrapper");

   procedure setButtonText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setButtonText_0_wrapper,
                     "__Qt4Ada_QWizard_setButtonText_0_wrapper");

   procedure setField_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Name : not null access constant Qt4.Strings.Internals.QString;
     Value : not null access constant Qt4.Variants.Internals.QVariant);
   pragma Import (C, setField_0_wrapper,
                     "__Qt4Ada_QWizard_setField_0_wrapper");

   procedure setOption_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Option;
     On : Qt4.bool);
   pragma Import (C, setOption_0_wrapper,
                     "__Qt4Ada_QWizard_setOption_0_wrapper");

   procedure setPage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Id : Qt4.Q_Integer;
     Page : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setPage_0_wrapper,
                     "__Qt4Ada_QWizard_setPage_0_wrapper");

   procedure setPixmap_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Pixmap;
     Pixmap : not null access constant Qt4.Pixmaps.Internals.QPixmap);
   pragma Import (C, setPixmap_0_wrapper,
                     "__Qt4Ada_QWizard_setPixmap_0_wrapper");

   procedure setStartId_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Id : Qt4.Q_Integer);
   pragma Import (C, setStartId_0_wrapper,
                     "__Qt4Ada_QWizard_setStartId_0_wrapper");

   procedure setSubTitleFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Format : Qt4.Text_Format);
   pragma Import (C, setSubTitleFormat_0_wrapper,
                     "__Qt4Ada_QWizard_setSubTitleFormat_0_wrapper");

   procedure setTitleFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Format : Qt4.Text_Format);
   pragma Import (C, setTitleFormat_0_wrapper,
                     "__Qt4Ada_QWizard_setTitleFormat_0_wrapper");

   procedure setWizardStyle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Style : Qt4.Wizards.Wizard_Wizard_Style);
   pragma Import (C, setWizardStyle_0_wrapper,
                     "__Qt4Ada_QWizard_setWizardStyle_0_wrapper");

   function startId_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, startId_0_wrapper,
                     "__Qt4Ada_QWizard_startId_0_wrapper");

   function subTitleFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Text_Format;
   pragma Import (C, subTitleFormat_0_wrapper,
                     "__Qt4Ada_QWizard_subTitleFormat_0_wrapper");

   function testOption_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Option : Qt4.Wizards.Wizard_Wizard_Option)
       return Qt4.bool;
   pragma Import (C, testOption_0_wrapper,
                     "__Qt4Ada_QWizard_testOption_0_wrapper");

   function titleFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Text_Format;
   pragma Import (C, titleFormat_0_wrapper,
                     "__Qt4Ada_QWizard_titleFormat_0_wrapper");

   function wizardStyle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Wizards.Wizard_Wizard_Style;
   pragma Import (C, wizardStyle_0_wrapper,
                     "__Qt4Ada_QWizard_wizardStyle_0_wrapper");

   procedure back_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, back_0_wrapper,
                     "__Qt4Ada_QWizard_back_0_wrapper");

   procedure next_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, next_0_wrapper,
                     "__Qt4Ada_QWizard_next_0_wrapper");

   procedure restart_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, restart_0_wrapper,
                     "__Qt4Ada_QWizard_restart_0_wrapper");

   pragma Style_Checks ("N");

   --------------
   -- Add_Page --
   --------------

   function Add_Page
    (Self : not null access Q_Wizard'Class;
     Page : not null access Qt4.Wizard_Pages.Q_Wizard_Page'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        addPage_0_wrapper
         (Self.QObject_View,
          Page.QObject_View);
   end Add_Page;

   ------------
   -- Button --
   ------------

   function Button
    (Self : not null access constant Q_Wizard'Class;
     Page : Qt4.Wizards.Wizard_Wizard_Button)
       return not null access Qt4.Abstract_Buttons.Q_Abstract_Button'Class
   is
   begin
      return
        Qt4.Abstract_Buttons.Q_Abstract_Button'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (button_0_wrapper
             (Self.QObject_View,
              Page)).all)'Access;
   end Button;

   -----------------
   -- Button_Text --
   -----------------

   function Button_Text
    (Self : not null access constant Q_Wizard'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Button)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      buttonText_0_wrapper
       (Self.QObject_View,
        Which,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Button_Text;

   ----------------
   -- Current_Id --
   ----------------

   function Current_Id
    (Self : not null access constant Q_Wizard'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        currentId_0_wrapper
         (Self.QObject_View);
   end Current_Id;

   ------------------
   -- Current_Page --
   ------------------

   function Current_Page
    (Self : not null access constant Q_Wizard'Class)
       return not null access Qt4.Wizard_Pages.Q_Wizard_Page'Class
   is
   begin
      return
        Qt4.Wizard_Pages.Q_Wizard_Page'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (currentPage_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Current_Page;

   -----------
   -- Field --
   -----------

   function Field
    (Self : not null access constant Q_Wizard'Class;
     Name : Qt4.Strings.Q_String)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      field_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Name),
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Field;

   ----------------------
   -- Has_Visited_Page --
   ----------------------

   function Has_Visited_Page
    (Self : not null access constant Q_Wizard'Class;
     Id : Qt4.Q_Integer)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasVisitedPage_0_wrapper
           (Self.QObject_View,
            Id));
   end Has_Visited_Page;

   ----------
   -- Page --
   ----------

   function Page
    (Self : not null access constant Q_Wizard'Class;
     Id : Qt4.Q_Integer)
       return not null access Qt4.Wizard_Pages.Q_Wizard_Page'Class
   is
   begin
      return
        Qt4.Wizard_Pages.Q_Wizard_Page'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (page_0_wrapper
             (Self.QObject_View,
              Id)).all)'Access;
   end Page;

   ------------
   -- Pixmap --
   ------------

   function Pixmap
    (Self : not null access constant Q_Wizard'Class;
     Id : Qt4.Wizards.Wizard_Wizard_Pixmap)
       return Qt4.Pixmaps.Q_Pixmap
   is
      Returns : Qt4.Pixmaps.Q_Pixmap;

   begin
      pixmap_0_wrapper
       (Self.QObject_View,
        Id,
        Qt4.Pixmaps.Internals.QPixmap_View (Returns));

      return Returns;
   end Pixmap;

   ----------------
   -- Set_Button --
   ----------------

   procedure Set_Button
    (Self : not null access Q_Wizard'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Button : not null access Qt4.Abstract_Buttons.Q_Abstract_Button'Class)
   is
   begin
      setButton_0_wrapper
       (Self.QObject_View,
        Which,
        Button.QObject_View);
   end Set_Button;

   ---------------------
   -- Set_Button_Text --
   ---------------------

   procedure Set_Button_Text
    (Self : not null access Q_Wizard'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setButtonText_0_wrapper
       (Self.QObject_View,
        Which,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Button_Text;

   ---------------
   -- Set_Field --
   ---------------

   procedure Set_Field
    (Self : not null access Q_Wizard'Class;
     Name : Qt4.Strings.Q_String;
     Value : Qt4.Variants.Q_Variant)
   is
   begin
      setField_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Name),
        Qt4.Variants.Internals.QVariant_View (Value));
   end Set_Field;

   ----------------
   -- Set_Option --
   ----------------

   procedure Set_Option
    (Self : not null access Q_Wizard'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Option;
     On : Standard.Boolean
       := True)
   is
   begin
      setOption_0_wrapper
       (Self.QObject_View,
        Which,
        Qt4.To_bool (On));
   end Set_Option;

   --------------
   -- Set_Page --
   --------------

   procedure Set_Page
    (Self : not null access Q_Wizard'Class;
     Id : Qt4.Q_Integer;
     Page : not null access Qt4.Wizard_Pages.Q_Wizard_Page'Class)
   is
   begin
      setPage_0_wrapper
       (Self.QObject_View,
        Id,
        Page.QObject_View);
   end Set_Page;

   ----------------
   -- Set_Pixmap --
   ----------------

   procedure Set_Pixmap
    (Self : not null access Q_Wizard'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Pixmap;
     Pixmap : Qt4.Pixmaps.Q_Pixmap)
   is
   begin
      setPixmap_0_wrapper
       (Self.QObject_View,
        Which,
        Qt4.Pixmaps.Internals.QPixmap_View (Pixmap));
   end Set_Pixmap;

   ------------------
   -- Set_Start_Id --
   ------------------

   procedure Set_Start_Id
    (Self : not null access Q_Wizard'Class;
     Id : Qt4.Q_Integer)
   is
   begin
      setStartId_0_wrapper
       (Self.QObject_View,
        Id);
   end Set_Start_Id;

   --------------------------
   -- Set_Sub_Title_Format --
   --------------------------

   procedure Set_Sub_Title_Format
    (Self : not null access Q_Wizard'Class;
     Format : Qt4.Text_Format)
   is
   begin
      setSubTitleFormat_0_wrapper
       (Self.QObject_View,
        Format);
   end Set_Sub_Title_Format;

   ----------------------
   -- Set_Title_Format --
   ----------------------

   procedure Set_Title_Format
    (Self : not null access Q_Wizard'Class;
     Format : Qt4.Text_Format)
   is
   begin
      setTitleFormat_0_wrapper
       (Self.QObject_View,
        Format);
   end Set_Title_Format;

   ----------------------
   -- Set_Wizard_Style --
   ----------------------

   procedure Set_Wizard_Style
    (Self : not null access Q_Wizard'Class;
     Style : Qt4.Wizards.Wizard_Wizard_Style)
   is
   begin
      setWizardStyle_0_wrapper
       (Self.QObject_View,
        Style);
   end Set_Wizard_Style;

   --------------
   -- Start_Id --
   --------------

   function Start_Id
    (Self : not null access constant Q_Wizard'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        startId_0_wrapper
         (Self.QObject_View);
   end Start_Id;

   ----------------------
   -- Sub_Title_Format --
   ----------------------

   function Sub_Title_Format
    (Self : not null access constant Q_Wizard'Class)
       return Qt4.Text_Format
   is
   begin
      return
        subTitleFormat_0_wrapper
         (Self.QObject_View);
   end Sub_Title_Format;

   -----------------
   -- Test_Option --
   -----------------

   function Test_Option
    (Self : not null access constant Q_Wizard'Class;
     Option : Qt4.Wizards.Wizard_Wizard_Option)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (testOption_0_wrapper
           (Self.QObject_View,
            Option));
   end Test_Option;

   ------------------
   -- Title_Format --
   ------------------

   function Title_Format
    (Self : not null access constant Q_Wizard'Class)
       return Qt4.Text_Format
   is
   begin
      return
        titleFormat_0_wrapper
         (Self.QObject_View);
   end Title_Format;

   ------------------
   -- Wizard_Style --
   ------------------

   function Wizard_Style
    (Self : not null access constant Q_Wizard'Class)
       return Qt4.Wizards.Wizard_Wizard_Style
   is
   begin
      return
        wizardStyle_0_wrapper
         (Self.QObject_View);
   end Wizard_Style;

   ----------
   -- Back --
   ----------

   procedure Back
    (Self : not null access Q_Wizard'Class)
   is
   begin
      back_0_wrapper
       (Self.QObject_View);
   end Back;

   ----------
   -- Next --
   ----------

   procedure Next
    (Self : not null access Q_Wizard'Class)
   is
   begin
      next_0_wrapper
       (Self.QObject_View);
   end Next;

   -------------
   -- Restart --
   -------------

   procedure Restart
    (Self : not null access Q_Wizard'Class)
   is
   begin
      restart_0_wrapper
       (Self.QObject_View);
   end Restart;

end Qt4.Wizards;
